﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace TreeViewDragInfo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            radTreeView.ExpandAll();

            radTreeView.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
            radTreeView.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
            radTreeView.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
            radTreeView.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
        }

        // OnDragQuery event handler
        private void OnDragQuery(object sender, DragDropQueryEventArgs e)
        {
            e.Options.ArrowCue = null;

        }

        // OnDropQuery event handler
        private void OnDropQuery(object sender, DragDropQueryEventArgs e)
        {
            e.Options.ArrowCue = null;
        }

        // OnDropInfo event handler
        private void OnDropInfo(object sender, DragDropEventArgs e)
        {
            e.Options.ArrowCue = null;

            var destination = e.Options.Destination;
            if (e.Options.Destination != null && e.Options.Destination is RadTreeViewItem)
            {
                infoBoxCurrentTarget.Text = (destination as RadTreeViewItem).Header.ToString();
            }
        }

        // OnDragInfo event handler
        private void OnDragInfo(object sender, DragDropEventArgs e)
        {
            if (e.Options.Status == DragStatus.DragInProgress)
            {
                ContentControl control = new ContentControl();
                control.Content = new TextBlock(){Text= "DragCue"};
                e.Options.DragCue = control;
            }
            double Xcoord = e.Options.RelativeDragPoint.X;
            double Ycoord = e.Options.RelativeDragPoint.Y;

            string mousePointInfoRow = "X: " + Xcoord + "  Y: " + Ycoord + "\n";
            infoBoxCurrentPosition.Text = mousePointInfoRow;

            //e.OriginalSource
        }
    }
}
